// AddrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BinEdit.h"
#include "AddrDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddrDlg dialog


CAddrDlg::CAddrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddrDlg)
	m_Radix = -1;
	m_Addr = 0;
	//}}AFX_DATA_INIT
}


void CAddrDlg::DoDataExchange(CDataExchange* pDX)
{
	char s[20];
	CString p;
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddrDlg)
	DDX_Radio(pDX, IDC_RADIX, m_Radix);
	if (!m_Radix)
		DDX_Text(pDX, IDC_ADDR, m_Addr);
	else
	{
		if (pDX->m_bSaveAndValidate)
		{
			GetDlgItemText(IDC_ADDR, p);
			if (!sscanf(p, "%x", &m_Addr))
			{
				MessageBox("  ", "BinEdit", MB_OK | MB_ICONEXCLAMATION);
				pDX->Fail();
			}
		}
		else
		{
			itoa(m_Addr, s, 16);
			SetDlgItemText(IDC_ADDR, s);
		}
	}
	DDV_MinMaxInt(pDX, m_Addr, 0, 2147483647);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddrDlg, CDialog)
	//{{AFX_MSG_MAP(CAddrDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddrDlg message handlers

BOOL CAddrDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CEdit *e = (CEdit *)GetDlgItem(IDC_ADDR);
	e->SetLimitText(10);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
