// ChangeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BinEdit.h"
#include "ChangeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChangeDlg dialog


CChangeDlg::CChangeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChangeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangeDlg)
	m_Radix = -1;
	m_Val = 0;
	//}}AFX_DATA_INIT
}


void CChangeDlg::DoDataExchange(CDataExchange* pDX)
{
	char s[10];
	CString p;
	int res;
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangeDlg)
	DDX_Radio(pDX, IDC_RADIX2, m_Radix);
	if (m_Radix == 2)
		DDX_Text(pDX, IDC_VAL, m_Val);
	else
	{
		if (pDX->m_bSaveAndValidate)
		{
			GetDlgItemText(IDC_VAL, p);
			if (m_Radix)
			{
				char q[] = "% ";
				switch (m_Radix)
				{
					case 1: q[1] = 'o'; break;
					case 3: q[1] = 'x';
				}
				res = sscanf(p, q, &m_Val);
			}
			else
			{
				int j = 0;
				res = 1;
				m_Val = 0;
				strcpy(s, p);
				for (int i = strlen(s) - 1; i >= 0; i--, j++)
				{
					if (s[i] != '0' && s[i] != '1')
					{
						res = 0;
						break;
					}
					m_Val |= (s[i] - '0') << j;
				}
			}
			if (!res)
			{
				MessageBox("  ", "BinEdit", MB_OK | MB_ICONEXCLAMATION);
				pDX->Fail();
			}
		}
		else
		{
			int r;
			switch (m_Radix)
			{
				case 0: r = 2; break;
				case 1: r = 8; break;
				case 2: r = 10; break;
				case 3: r = 16;
			}
			itoa(m_Val, s, r);
			SetDlgItemText(IDC_VAL, s);
		}
	}
	DDV_MinMaxInt(pDX, m_Val, 0, 255);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChangeDlg, CDialog)
	//{{AFX_MSG_MAP(CChangeDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeDlg message handlers

BOOL CChangeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CEdit *e = (CEdit *)GetDlgItem(IDC_VAL);
	e->SetLimitText(8);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
