// BinEditDoc.h : interface of the CBinEditDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BINEDITDOC_H__BAA21E49_84ED_11D5_B5F3_5254AB134FE2__INCLUDED_)
#define AFX_BINEDITDOC_H__BAA21E49_84ED_11D5_B5F3_5254AB134FE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CBinEditDoc : public CDocument
{
protected: // create from serialization only
	CBinEditDoc();
	DECLARE_DYNCREATE(CBinEditDoc)

// Attributes
public:
	CFile *file;

// Operations
public:
	void GetData(int pos, unsigned char *data, int size);
	int GetFileSize();
	void WriteByte(int addr, char b);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBinEditDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBinEditDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBinEditDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BINEDITDOC_H__BAA21E49_84ED_11D5_B5F3_5254AB134FE2__INCLUDED_)
