// SelectsymDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BinEdit.h"
#include "SelectsymDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelectsymDlg dialog


CSelectsymDlg::CSelectsymDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectsymDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectsymDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSelectsymDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	if (pDX->m_bSaveAndValidate)
	{
		CListBox *lb = (CListBox *)GetDlgItem(IDC_SYMBOLS);
		CString s;
		lb->GetText(lb->GetCurSel(), s);
		m_Sym = s[0];
	}
	//{{AFX_DATA_MAP(CSelectsymDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectsymDlg, CDialog)
	//{{AFX_MSG_MAP(CSelectsymDlg)
	ON_CBN_SELCHANGE(IDC_FONTS, OnSelchangeFonts)
	ON_LBN_DBLCLK(IDC_SYMBOLS, OnDblclkSymbols)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectsymDlg message handlers

int CALLBACK EnumFontFamProc(
    ENUMLOGFONT FAR*  lpelf,	// address of logical-font data 
    NEWTEXTMETRIC FAR*  lpntm,	// address of physical-font data 
    int  FontType,	// type of font 
    LPARAM  lParam 	// address of application-defined data  
   )
{
	CComboBox *cb = (CComboBox *)lParam;
	if (lpelf->elfFullName[0])
		cb->AddString((char *)lpelf->elfFullName);
	return 1;
}

BOOL CSelectsymDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	char s[] = " ";
	
	CListBox *lb = (CListBox *)GetDlgItem(IDC_SYMBOLS);
	CComboBox *cb = (CComboBox *)GetDlgItem(IDC_FONTS);
	CDC dc;
	dc.CreateDC("DISPLAY", NULL, NULL, NULL);
	EnumFontFamilies(dc, NULL, (FONTENUMPROC)EnumFontFamProc, (long)cb);
	lb->SetColumnWidth(16);
	cb->SelectString(-1, "Courier New Cyr");
	OnSelchangeFonts();

	for (int i = 0; i < 32; i++)
		for (int j = 0; j < 8; j++)
		{
			s[0] = codetable[j * 32 + i];
			lb->AddString(s);
		}
	
	s[0] = m_Sym;
	lb->SelectString(-1, s);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSelectsymDlg::OnSelchangeFonts() 
{
	CListBox *lb = (CListBox *)GetDlgItem(IDC_SYMBOLS);
	CComboBox *cb = (CComboBox *)GetDlgItem(IDC_FONTS);
	CFont *pFont = new CFont();
	CString s;
	cb->GetLBText(cb->GetCurSel(), s);
	pFont->CreateFont(16, 0, 0, 0, FW_DONTCARE, 0, 0, 0, 
		DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY, DEFAULT_PITCH, s);
	lb->SetFont(pFont);
}

void CSelectsymDlg::OnDblclkSymbols() 
{
	OnOK();
}
